
import sys

def mix(s1, s2):
	while True: yield s1.next() + s2.next()

def seq(s1, s2):
	for s in s1: yield s
	for s in s2: yield s

def sync(s1, s2):
	while True: yield s1.next() * s2.next()

def echo(s, delay, strength):
	t, mem = 0, [0]*delay
	for sample in s:
		t = (t + 1) % delay
		mem[t] = sample + mem[t] * strength
		yield mem[t]

def square(pitch, duration):
	for t in range(duration): yield (t/pitch)%2

def sawtooth(pitch, duration):
	for t in range(duration): yield (float(t)/pitch)%1

def clip(sample):
	if sample < 0: return 0
	if sample > 255: return 255
	return int(sample)

def melody(notes):
	if notes == []: return ()
	pitch, dur = notes[0]
	return seq(square(pitch, dur), melody(notes[1:]))

o = sys.stdout
for s in melody([(30,4000), (20,4000), (40,8000)]):
	o.write(chr(clip(s*255)))

